<%@  page pageEncoding="utf-8" contentType="text/html;charset=utf-8" import="com.novell.webaccess.common.JSPConduit, com.novell.emframe.dev.eMFrameUtils" %>
<%   JSPConduit c = JSPConduit.getJSPConduit(request);
  /*-------------------------------------------------------------------------------- */
  /*-- getGrade                                                                   -- */
  /*-- 	Determines the grade of a sequence by looking thru all of its selected  -- */
  /*-- 	login and post-login methods and by using its sequence type (and/or)    -- */
  /*-------------------------------------------------------------------------------- */%>
 	function getGrade( aSelectedLoginMethods, aSelectedPostLoginMethods, strSequenceType )
 	{
 		var bBiometric = false;
 		var bToken = false;
 		var bPassword = false;
 		var strGrade = "";

        if( strSequenceType == "<%= c.string("NMAS.Sequence.TYPE_AND") %>")
        {   <%/*-- we have an "AND" sequence -- */%>
 	        bBiometric = false;
 	        bToken = false;
 	        bPassword = false;
 	    }
 	    else
 	    {   <%/*-- we have an "OR" sequence -- */%>
 	        bBiometric = true;
 	        bToken = true;
 	        bPassword = true;
 	    }

 		<%/*--
			Compute the grade for AND sequences
	 		For each new grade type encountered we set
			the corresponding grade boolean to true
		-- */%>
        if( strSequenceType  == "<%= c.string("NMAS.Sequence.TYPE_AND") %>" )
        {
		 	<%/*-- go thru once for login methods and once for post-login methods -- */%>
			for ( var methodType=0; methodType < 2; methodType++ )
			{
		 		if ( methodType == 0 )
					aCurMethods =  aSelectedLoginMethods;
				else
					aCurMethods =  aSelectedPostLoginMethods;

	 		    for (var i = 0; i < aCurMethods.length; i++)
	 		    {
				    <%/*-- A single method can implement more than one grade
				    	Thus we check to see what of all specific grades
				    	this method includes by doing a substring match
					-- */%>
					var theMethod = aCurMethods[i];
					var theGrade = getGradeOfMethod( theMethod );
				    if( theGrade.indexOf("<%= c.string("NMAS.Sequence.BIOMETRIC_GRADE") %>")!= -1)
				    {
					    bBiometric = true;
				    }
				    if (theGrade.indexOf("<%= c.string("NMAS.Sequence.TOKEN_GRADE") %>") != -1)
				    {
					    bToken = true;
				    }
				    if (theGrade.indexOf("<%= c.string("NMAS.Sequence.PASSWORD_GRADE") %>") != -1)
				    {
					    bPassword = true;
				    }
	 		    }
			}

 		    <%/*-- If method is biometric grade add it to the grade -- */%>
 		    if (bBiometric)
 		    {
 			    strGrade = "<%= c.string("NMAS.Sequence.BIOMETRIC_GRADE") %>";
 		    }

 		    <%/*-- If method is token grade add it to the grade -- */%>
 		    if (bToken)
 		    {
 			    if ( strGrade == "" )
 			    {
 				    strGrade = "<%= c.string("NMAS.Sequence.TOKEN_GRADE") %>";
 			    }
 			    else
 			    {
 				    strGrade += " & " + "<%= c.string("NMAS.Sequence.TOKEN_GRADE") %>";
 			    }
 		    }
 		    <%/*-- If method is bPassword grade add it to the grade -- */%>
 		    if (bPassword)
 		    {
 			    if ( strGrade == "" )
 			    {
 				    strGrade = "<%= c.string("NMAS.Sequence.PASSWORD_GRADE") %>";
 			    }
 			    else
 			    {
 				    strGrade += " & " + "<%= c.string("NMAS.Sequence.PASSWORD_GRADE") %>";
 			    }
 		    }
	 	}
	 	else
	 	{
			<%/*-- go thru once for login methods and once for post-login methods -- */%>
			for ( var methodType=0; methodType < 2; methodType++ )
			{
		 		if ( methodType == 0 )
					aCurMethods =  aSelectedLoginMethods;
				else
					aCurMethods =  aSelectedPostLoginMethods;


	 		    <%/*-- Compute the grade for OR sequences
		 		    For an OR sequence to have the bBiometric grade THEN
		 			all methods must have the biomentric grade.  If any method does
		 			not have the bBiometric grade then the sequence is not
		 			bBiometric grade. Thus having initialized all grade types
		 			to true we set them to false upon encountering a method
		 			that is not of a given grade.
				-- */%>
	 		    for (var i = 0; i < aCurMethods.length; i++)
	 		    {
					var theMethod = aCurMethods[i];
					var theGrade = getGradeOfMethod( theMethod );

				    if(theGrade.indexOf("<%= c.string("NMAS.Sequence.BIOMETRIC_GRADE") %>")== -1)
				    {
					    bBiometric = false;
				    }
				    if (theGrade.indexOf("<%= c.string("NMAS.Sequence.TOKEN_GRADE") %>") == -1)
				    {
					    bToken = false;
				    }
				    if (theGrade.indexOf("<%= c.string("NMAS.Sequence.PASSWORD_GRADE") %>") == -1)
				    {
					    bPassword = false;
				    }
	 		    }

	     		if (aCurMethods.length != 0)
	 		    {

	 		        <%/*-- If method is biometric grade add it to the grade -- */%>
	 		        if (bBiometric)
	 		        {
	 			        strGrade = "<%= c.string("NMAS.Sequence.BIOMETRIC_GRADE") %>";
	 		        }

	 		        <%/*-- If method is token grade add it to the grade -- */%>
	 		        if (bToken)
	 		        {
	 			        if ( strGrade == "" )
	 			        {
	 				        strGrade = "<%= c.string("NMAS.Sequence.TOKEN_GRADE") %>";
	 			        }
	 			        else
	 			        {
	 				        strGrade += " & " + "<%= c.string("NMAS.Sequence.TOKEN_GRADE") %>";
	 			        }
	 		        }

	 		        <%/*-- If method is password grade add it to the grade -- */%>
	 		        if (bPassword)
	 		        {
	 			        if ( strGrade == "" )
	 			        {
	 				        strGrade = "<%= c.string("NMAS.Sequence.PASSWORD_GRADE") %>";
	 			        }
	 			        else
	 			        {
	 				        strGrade += " & " + "<%= c.string("NMAS.Sequence.PASSWORD_GRADE") %>";
	 			        }
	 		        }
	 		    }
	 		}  <%/*-- for -- */%>
		} <%/*-- else -- */

 		  /*-- If the method sequence is none of biometric OR token OR password
	 		then assigned the grade as logged-in.
	 		If there are no selected methods then the grade is ""
		-- */%>
		if ( (aSelectedLoginMethods.length == 0) && (aSelectedPostLoginMethods.length == 0) )
		{
			strGrade = "";
		}
 		else if ( strGrade == "" )
 		{
 			strGrade = "<%= c.string("NMAS.Sequence.LOGGED_IN_GRADE") %>";
 		}

 		return strGrade;
 	}

<%/*---------------------------------------------------------------------------------------------- */
  /*-- 	This function looks thru the login methods and post login methods that were sent down -- */
  /*-- 	and finds the grade associated with a particular method name                          -- */
  /*---------------------------------------------------------------------------------------------- */%>
	function getGradeOfMethod( methodName )
	{
		var grade = "";

		for ( var i=0; i<aAllLoginMethods.length; i++ )
		{
			if ( methodName == aAllLoginMethods[i][NAME] )
			{
				grade = aAllLoginMethods[i][METHOD_GRADE];
				break;
			}
		}
		for ( var i=0; i<aAllPostLoginMethods.length; i++ )
		{
			if ( methodName == aAllPostLoginMethods[i][NAME] )
			{
				grade = aAllPostLoginMethods[i][METHOD_GRADE];
				break;
			}
		}

		return grade;
	}
